<?php
namespace Importacao\Logic\Bases\ModeloImportacao\References;

use \Importacao\Logic\Bases\ModeloImportacao\References\Reference;

class Autoincrement implements Reference
{

	const REFERENCE_AUTOINCREMENT = "/\@AUTOINCREMENT\@/";

	public function getRegularExpression() 
	{
		return self::REFERENCE_AUTOINCREMENT;
	}

	public function getValorReferencia($nomeTabela, $nomeColuna, $metaDado, $valorFixo, 
									   $entityContainer, $linhaDados = null, $fixedFields = null)
	{
		$dadoColuna = $this->getAutoincrementValue($nomeTabela, str_replace("#", "", $nomeColuna));
		return preg_replace(self::REFERENCE_AUTOINCREMENT, $dadoColuna, $metaDado);
	}

	private function getAutoincrementValue($tableName, $columnName) 
	{
		if (!isset($this->primaryKeys[$tableName][$columnName])) {
			$this->primaryKeys[$tableName][$columnName] = 0;
		}

		return ++$this->primaryKeys[$tableName][$columnName];
	}

}