/* Tabela CLIENTE: Cliente */
/* Descrio: A trigger insere registros na tabela ALTERAPARTSPED a partir de alteraes
na tabela CLIENTE */
/* Objetivo: Registrar as alteraes realizadas nos campos NMRAZSOCCLIE, NRINSJURCLIE, NRINSESTCLIE, NRINSCSUFRAMACL
da tabela CLIENTE, para serem utilizadas na gerao do registro 0175 do Sped Fiscal */

create or replace
TRIGGER ALTERA_CLIENTE_SPED
AFTER UPDATE
ON CLIENTE FOR EACH ROW
DECLARE
  V_NRSEQALTPARTSPED NUMBER;
  V_DTOPER           DATE;
BEGIN
  IF UPDATING THEN
    IF (((:OLD.NMRAZSOCCLIE <> :NEW.NMRAZSOCCLIE) OR (:NEW.NMRAZSOCCLIE IS NULL)) AND (:OLD.NMRAZSOCCLIE IS NOT NULL)) THEN
       BEGIN
            SELECT MAX(NRSEQALTPARTSPED)
              INTO V_NRSEQALTPARTSPED
              FROM ALTERAPARTSPED;
       EXCEPTION
            WHEN NO_DATA_FOUND THEN
                 V_NRSEQALTPARTSPED := 0;
       END;
       V_NRSEQALTPARTSPED := NVL(V_NRSEQALTPARTSPED,0)+1;
       V_DTOPER := SYSDATE;

       BEGIN
            DELETE ALTERAPARTSPED
             WHERE CDCHAVE = 'C'||:OLD.CDCLIENTE
               AND CDCAMPO = '03'
               AND DTALTERACAO < V_DTOPER;
       END;

       INSERT INTO ALTERAPARTSPED (NRSEQALTPARTSPED,CDCHAVE,CDCAMPO,DTALTERACAO,DSCONTEUDOANT)
            VALUES (LPAD(V_NRSEQALTPARTSPED,'10','0'),'C'||:OLD.CDCLIENTE,'03',V_DTOPER,:OLD.NMRAZSOCCLIE);
    END IF;

    IF (((:OLD.NRINSJURCLIE <> :NEW.NRINSJURCLIE) OR (:NEW.NRINSJURCLIE IS NULL)) AND (:OLD.NRINSJURCLIE IS NOT NULL)) THEN
       BEGIN
            SELECT MAX(NRSEQALTPARTSPED)
              INTO V_NRSEQALTPARTSPED
              FROM ALTERAPARTSPED;
       EXCEPTION
            WHEN NO_DATA_FOUND THEN
                 V_NRSEQALTPARTSPED := 0;
       END;
       V_NRSEQALTPARTSPED := NVL(V_NRSEQALTPARTSPED,0)+1;
       V_DTOPER := SYSDATE;

       BEGIN
            DELETE ALTERAPARTSPED
             WHERE CDCHAVE = 'C'||:OLD.CDCLIENTE
               AND CDCAMPO = DECODE(:OLD.IDTPIJURCLIE,'F','06','05')
               AND DTALTERACAO < V_DTOPER;
       END;

       INSERT INTO ALTERAPARTSPED (NRSEQALTPARTSPED,CDCHAVE,CDCAMPO,DTALTERACAO,DSCONTEUDOANT)
            VALUES (LPAD(V_NRSEQALTPARTSPED,'10','0'),'C'||:OLD.CDCLIENTE,DECODE(:OLD.IDTPIJURCLIE,'F','06','05'),V_DTOPER,:OLD.NRINSJURCLIE);
    END IF;

    IF (((:OLD.NRINSESTCLIE <> :NEW.NRINSESTCLIE) OR (:NEW.NRINSESTCLIE IS NULL)) AND (:OLD.NRINSESTCLIE IS NOT NULL)) THEN
       BEGIN
            SELECT MAX(NRSEQALTPARTSPED)
              INTO V_NRSEQALTPARTSPED
              FROM ALTERAPARTSPED;
       EXCEPTION
            WHEN NO_DATA_FOUND THEN
                 V_NRSEQALTPARTSPED := 0; 
       END;
       V_NRSEQALTPARTSPED := NVL(V_NRSEQALTPARTSPED,0)+1;
       V_DTOPER := SYSDATE;

       BEGIN
            DELETE ALTERAPARTSPED
             WHERE CDCHAVE = 'C'||:OLD.CDCLIENTE
               AND CDCAMPO = '07'
               AND DTALTERACAO < V_DTOPER;
       END;
       
       INSERT INTO ALTERAPARTSPED (NRSEQALTPARTSPED,CDCHAVE,CDCAMPO,DTALTERACAO,DSCONTEUDOANT) 
            VALUES (LPAD(V_NRSEQALTPARTSPED,'10','0'),'C'||:OLD.CDCLIENTE,'07',V_DTOPER,:OLD.NRINSESTCLIE);    
    END IF;
    
    IF (((:OLD.NRINSCSUFRAMACL <> :NEW.NRINSCSUFRAMACL) OR (:NEW.NRINSCSUFRAMACL IS NULL)) AND (:OLD.NRINSCSUFRAMACL IS NOT NULL)) THEN
       BEGIN
            SELECT MAX(NRSEQALTPARTSPED)
              INTO V_NRSEQALTPARTSPED
              FROM ALTERAPARTSPED;
       EXCEPTION
            WHEN NO_DATA_FOUND THEN
                 V_NRSEQALTPARTSPED := 0; 
       END;
       V_NRSEQALTPARTSPED := NVL(V_NRSEQALTPARTSPED,0)+1;
       V_DTOPER := SYSDATE;

       BEGIN
            DELETE ALTERAPARTSPED
             WHERE CDCHAVE = 'C'||:OLD.CDCLIENTE
               AND CDCAMPO = '09'
               AND DTALTERACAO < V_DTOPER;
       END;
       
       INSERT INTO ALTERAPARTSPED (NRSEQALTPARTSPED,CDCHAVE,CDCAMPO,DTALTERACAO,DSCONTEUDOANT) 
            VALUES (LPAD(V_NRSEQALTPARTSPED,'10','0'),'C'||:OLD.CDCLIENTE,'09',V_DTOPER,:OLD.NRINSCSUFRAMACL);    
    END IF;
  END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ALTERA_CLIENTE_SPED','5.85.000'); END;
/