<?php
namespace Teknisa\Model\Gestaopessoas\Entities;

use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class GpeVinculoh extends \Teknisa\Model\Gestaopessoas\Entities\Base\GpeVinculoh {
    
    const IDMULTVINC_UNICO = 'UNICO';
    const IDMULTVINC_PRIMARIO = 'PRIMARIO';
    
    public function atualizaDataBaseFerias($nova_data_base) {
        $this->setDtbaseferias($nova_data_base);
    }

    public function atualizaNrDependentesImpostoRenda($nr_dependentes) {
        $this->setNrdependir($nr_dependentes);
    }

    public function atualizaNrDependentesSalarioFamilia($nr_dependentes) {
        $this->setNrdependsfam($nr_dependentes);
    }
    
    public function atualizaHistorico($mesCompetencia, $dtBaseFerias = null){
    
        $mesCompetencia = DateUtil::getDataDeString(substr($mesCompetencia, 0 ,10), DateUtil::FORMATO_BRASILEIRO, true);
        
        $vinculo = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_VINCULOH)->retornaHistoricoCompetencia(
            $this->getNrorg(), $this->getNrvinculom(),
            $mesCompetencia
        );
        
        if(!$vinculo){
            $vinculoh = new self();
            $vinculoh = clone $this;
            $vinculoh->setNrvinculoh(\HCM\Util\NovoCodigo::geraCodigo($this->getNrorg(), 'GPE_VINCULOH', 1, 12, true));
            $vinculoh->setDtmescompetenc($mesCompetencia);
            $vinculoh->setDtbaseferias($dtBaseFerias);
            \Setforms2\Shared\Registry::getEntityManager()->persist($vinculoh);
            \Setforms2\Shared\Registry::getEntityManager()->flush($vinculoh);
        }else{
            $vinculo->setDtbaseferias($dtBaseFerias);
            \Setforms2\Shared\Registry::getEntityManager()->persist($vinculo);
            \Setforms2\Shared\Registry::getEntityManager()->flush($vinculo);
        }
    }
    
}